package de.donmanfred;

import java.util.Iterator;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseReference;

import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.objects.collections.Map.MyMap;

@ShortName("DataSnapshot")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onSigned(sign As Object)"})
//@DependsOn(values={"com.android.support:support-v4"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 */

public class DataSnapshotWrapper extends AbsObjectWrapper<DataSnapshot> {
	private BA ba;

	public void Initialize(final BA ba, DataSnapshot snapshot) {
		this.ba = ba;

		final DataSnapshot _obj = snapshot;
		setObject(_obj);
	}

	public boolean hasChildren(){
		return getObject().hasChildren();
	}
	/**
	 * Can be used to determine if this 
	 * DataSnapshot has data at a 
	 * particular location
	 */
	public boolean hasChild(String child){
		return getObject().hasChild(child);
	}
	/**
	 * Get a DataSnapshot for the location 
	 * at the specified relative path.
	 */
	public DataSnapshot getChild(String path){
		return getObject().child(path);
	}
	public Object getValue(){
  	java.util.Map<Object, Object> mm = (java.util.Map<Object, Object>) getObject().getValue();
  	
  	MyMap map = new anywheresoftware.b4a.objects.collections.Map.MyMap();
  	for (Iterator it = mm.keySet().iterator(); it.hasNext(); ){
      Object key = it.next();
      Object value = mm.get(key);
      map.put(key, value);
  	}
  	return map;
	}

	public Object Value2Map(Object value){
  	java.util.Map<Object, Object> mm = (java.util.Map<Object, Object>) value;
  	
  	MyMap map = new anywheresoftware.b4a.objects.collections.Map.MyMap();
  	for (Iterator it = mm.keySet().iterator(); it.hasNext(); ){
      Object key = it.next();
      Object val = mm.get(key);
      map.put(key, val);
  	}
  	return map;
	}
	
	/**
	 * Returns true if the snapshot 
	 * contains a non-null value.
	 */
	public boolean exists(){
		return getObject().exists();
	}
		
	public long getChildrenCount(){
		return getObject().getChildrenCount();
	}
	/**
	 * Gives access to all of the 
	 * immediate children of this snapshot.
	 */
	public Iterable<DataSnapshot> getChildren(){
		return getObject().getChildren();
	}
	public String getKey(){
		return getObject().getKey();
	}
	/**
	 * Returns the priority of the data 
	 * contained in this snapshot as a 
	 * native type.
	 */
	public Object getPriority(){
		return getObject().getPriority();
	}
	/**
	 * Used to obtain a reference to 
	 * the source location for this 
	 * snapshot.
	 */
	public DatabaseReference getRef(){
		return getObject().getRef();
	}
	
	
}
