package de.donmanfred;

import java.util.HashMap;
import java.util.Iterator;

import org.json.JSONObject;

import com.google.firebase.database.ChildEventListener;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.DatabaseReference.CompletionListener;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;

import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.objects.collections.Map;
import anywheresoftware.b4a.objects.collections.Map.MyMap;

@ShortName("DatabaseReference")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@ActivityObject
@Events(values={"onCancelled(errnum as Int,error As String, errObj As Object)",
		"onDataChange(snapshot As Object)",
		"onChildAdded(snapshot As Object, child As String)",
		"onChildChanged(snapshot As Object, child As String)",
		"onChildMoved(snapshot As Object, child As String)",
		"onChildRemoved(snapshot As Object)",
		"onComplete(errorCode As Int, errorMessage As String, errObj As Object, dbRef As Object)",
		})
//@DependsOn(values={"com.android.support:support-v4"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 */

public class DatabaseReferenceWrapper extends AbsObjectWrapper<DatabaseReference> {
	private BA ba;
	private String eventName;
	public void Initialize(final BA ba, String EventName, DatabaseReference reference) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		final DatabaseReference _obj = reference;
		final String eventName = EventName.toLowerCase(BA.cul);
		setObject(_obj);
		
	}
	public void addValueEventListener(final BA ba){
		ValueEventListener vel = new ValueEventListener(){
			@Override
			public void onCancelled(DatabaseError error) {
	 			if (ba.subExists(eventName + "_oncancelled")) {
  				BA.Log("lib:Raising.. "+eventName + "_oncancelled()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncancelled", true, new Object[] {error.getCode(),error.getMessage(), error});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_oncancelled");
  			}
			}
			@Override
			public void onDataChange(DataSnapshot snapshot) {
				// TODO Auto-generated method stub				
	 			if (ba.subExists(eventName + "_ondatachange")) {
  				BA.Log("lib:Raising.. "+eventName + "_ondatachange()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_ondatachange", true, new Object[] {snapshot});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_ondatachange");
  			}
			}};		
		
		getObject().addValueEventListener(vel);
		
	}
	public void addListenerForSingleValueEvent(final BA ba){
		ValueEventListener lvev = new ValueEventListener(){

			@Override
			public void onCancelled(DatabaseError error) {
	 			if (ba.subExists(eventName + "_oncancelled")) {
  				BA.Log("lib:Raising.. "+eventName + "_oncancelled()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncancelled", true, new Object[] {error.getCode(),error.getMessage(), error});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_oncancelled");
  			}
				
			}

			@Override
			public void onDataChange(DataSnapshot snapshot) {
				// TODO Auto-generated method stub
	 			if (ba.subExists(eventName + "_ondatachange")) {
  				BA.Log("lib:Raising.. "+eventName + "_ondatachange()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_ondatachange", true, new Object[] {snapshot});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_ondatachange");
  			}
				
			}};
		
		
		getObject().addListenerForSingleValueEvent(lvev);
	}
	public void addChildEventListener(final BA ba){
		ChildEventListener cel = new ChildEventListener(){
			@Override
			public void onCancelled(DatabaseError error) {
	 			if (ba.subExists(eventName + "_oncancelled")) {
  				BA.Log("lib:Raising.. "+eventName + "_oncancelled()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncancelled", true, new Object[] {error.getCode(),error.getMessage(), error});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_oncancelled");
  			}
			}
			@Override
			public void onChildAdded(DataSnapshot snapshot, String child) {
	 			if (ba.subExists(eventName + "_onchildadded")) {
  				BA.Log("lib:Raising.. "+eventName + "_onchildadded()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onchildadded", true, new Object[] {snapshot,child});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onchildadded");
  			}
			}
			@Override
			public void onChildChanged(DataSnapshot snapshot, String child) {
	 			if (ba.subExists(eventName + "_onchildchanged")) {
  				BA.Log("lib:Raising.. "+eventName + "_onchildchanged()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onchildchanged", true, new Object[] {snapshot,child});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onchildchanged");
  			}
			}
			@Override
			public void onChildMoved(DataSnapshot snapshot, String child) {
	 			if (ba.subExists(eventName + "_onchildmoved")) {
  				BA.Log("lib:Raising.. "+eventName + "_onchildmoved()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onchildmoved", true, new Object[] {snapshot,child});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onchildmoved");
  			}
			}
			@Override
			public void onChildRemoved(DataSnapshot snapshot) {
	 			if (ba.subExists(eventName + "_onchildremoved")) {
  				BA.Log("lib:Raising.. "+eventName + "_onchildremoved()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onchildremoved", true, new Object[] {snapshot});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onchildremoved");
  			}
			}};
			getObject().addChildEventListener(cel);
	}
  /**
   * Create a reference to an auto-
   * generated child location.
   */
	public DatabaseReference push(){
    return getObject().push();
  }
  /**
   * By calling `keepSynced(true)` on a location, the data for that 
   * location will automatically be downloaded and kept in sync, 
   * even when no listeners are attached for that location.
   */
  public void keepSynced(boolean keepSynced){
		getObject().keepSynced(keepSynced);
	}


  /**
   * Set the value at this location to 'null'
   */
  public void removeValue(){
  	CompletionListener cl = new CompletionListener(){

			@Override
			public void onComplete(DatabaseError error, DatabaseReference dbRef) {
				// TODO Auto-generated method stub
	 			if (ba.subExists(eventName + "_oncomplete")) {
  				BA.Log("lib:Raising.. "+eventName + "_oncomplete()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {error.getCode(),error.getMessage(), error});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_oncomplete");
  			}

			}};
  	
			getObject().removeValue(cl);
  }


  @SuppressWarnings("unchecked")
	public void updateChildren(final BA pba, String EventName, Map map){
		this.eventName = EventName.toLowerCase(BA.cul);

  	java.util.Map<Object, Object> mm = map.getObject();
  	java.util.Map<String, Object> value = new HashMap<String, Object>();
  	
  	for (Iterator it = mm.keySet().iterator(); it.hasNext(); ){
      Object key = it.next();
      Object val = mm.get(key);
      value.put((String)key, val);
  	}
  	
  	getObject().updateChildren(value, new CompletionListener(){

				@Override
				public void onComplete(DatabaseError error, DatabaseReference dbRef) {
					// TODO Auto-generated method stub
		 			if (pba.subExists(eventName + "_oncomplete")) {
	  				BA.Log("lib:Raising.. "+eventName + "_oncomplete()");								
	  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
	  				if (error != null){
	  					pba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {error.getCode(),error.getMessage(),error,dbRef});
	  				} else {
		  				pba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {0,"OK",error,dbRef});
	  					
	  				}
	  			}else {
	  				BA.Log("lib: NOTFOUND '"+eventName + "_oncomplete");
	  			}

				}
  	});
  }

  
//  public void setValue2(Object ref, Map map){
//  	java.util.Map<String, Object> mm = (java.util.Map<String, Object>) map;
//
//  	CompletionListener cl = new CompletionListener(){
//
//			@Override
//			public void onComplete(DatabaseError error, DatabaseReference dbRef) {
//				// TODO Auto-generated method stub
//	 			if (ba.subExists(eventName + "_oncomplete")) {
//  				BA.Log("lib:Raising.. "+eventName + "_oncomplete()");								
//  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
//  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {error.getCode(),error.getMessage(),error});
//  			}else {
//  				BA.Log("lib: NOTFOUND '"+eventName + "_oncomplete");
//  			}
//
//			}};
//  	
//			getObject().setValue(ref, mm, cl);
//  }

//  public void setValue2(Object value){
//  	CompletionListener cl = new CompletionListener(){
//
//			@Override
//			public void onComplete(DatabaseError error, DatabaseReference dbRef) {
//				// TODO Auto-generated method stub
//	 			if (ba.subExists(eventName + "_oncomplete")) {
//  				BA.Log("lib:Raising.. "+eventName + "_oncomplete()");								
//  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
//  				if(error == null){
//    				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {-4096,"",error});
//  				} else {
//    				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {error.getCode(),error.getMessage(),error});
//  				}
//  			}else {
//  				BA.Log("lib: NOTFOUND '"+eventName + "_oncomplete");
//  			}
//
//			}};
//  	
//			JSONObject json = new JSONObject((java.util.Map) value);
//			getObject().setValue(json, cl);
//  }

  public void setValue(Map value){
  	java.util.Map<Object, Object> mm = value.getObject();

  	CompletionListener cl = new CompletionListener(){

			@Override
			public void onComplete(DatabaseError error, DatabaseReference dbRef) {
				// TODO Auto-generated method stub
	 			if (ba.subExists(eventName + "_oncomplete")) {
  				BA.Log("lib:Raising.. "+eventName + "_oncomplete(1)");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				if(error == null){
    				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {-4096,"",error, dbRef});
  				} else {
    				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {error.getCode(),error.getMessage(),error,dbRef});
  				}
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_oncomplete");
  			}

			}};
  	
			//JSONObject json = new JSONObject((java.util.Map) value);
			getObject().setValue(mm, cl);
  }

	public void setEventName(final BA ba, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
	}

  
  
//  public void setValue(Map value){
//  	java.util.Map<Object, Object> mm = value.getObject();
//
//  	CompletionListener cl = new CompletionListener(){
//
//			@Override
//			public void onComplete(DatabaseError error, DatabaseReference dbRef) {
//				// TODO Auto-generated method stub
//	 			if (ba.subExists(eventName + "_oncomplete")) {
//  				BA.Log("lib:Raising.. "+eventName + "_oncomplete()");								
//  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
//  				if(error == null){
//    				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {-4096,"",error});
//  				} else {
//    				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_oncomplete", true, new Object[] {error.getCode(),error.getMessage(),error});
//  				}
//  			}else {
//  				BA.Log("lib: NOTFOUND '"+eventName + "_oncomplete");
//  			}
//
//			}};
//  	
//			//JSONObject json = new JSONObject((java.util.Map) value);
//			getObject().setValue(mm, cl);
//  }

  
  
  
  /**
   * Get a reference to location 
   * relative to this one
   */
	public DatabaseReference Child(String child){
		return getObject().child(child);
	}
	public DatabaseReference Parent(){
		return getObject().getParent();
	}
	public DatabaseReference Ref(){
		return getObject().getRef();
	}
	public DatabaseReference Root(){
		return getObject().getRoot();
	}
	/**
	 * Gets the Database instance associated 
	 * with this reference.
	 */
	public FirebaseDatabase Database(){
		return getObject().getDatabase();
	}
	/**
	 * Manually disconnect the Firebase Database 
	 * client from the server and disable 
	 * automatic reconnection.
	 */
	@SuppressWarnings("static-access")
	public void goOffline(){
		getObject().goOffline();
	}
	/**
	 * Manually reestablish a connection to the 
	 * Firebase Database server and enable 
	 * automatic reconnection.
	 */
	@SuppressWarnings("static-access")
	public void goOnline(){
		getObject().goOnline();
	}

	public String getKey(){
		return getObject().getKey();
	}
	public Query LimitToLast(int count){
		return getObject().limitToLast(count);
	}
	public Query LimitToFirst(int count){
		return getObject().limitToFirst(count);
	}

	public Query orderByChild(String child){
		return getObject().orderByChild(child);
	}
	public Query orderByKey(){
		return getObject().orderByKey();
	}
	public Query orderByPriority(){
		return getObject().orderByPriority();
	}
	public Query orderByValue(){
		return getObject().orderByValue();
	}
	
	public Object Value2Map(Object value){
  	java.util.Map<Object, Object> mm = (java.util.Map<Object, Object>) value;
  	
  	MyMap map = new anywheresoftware.b4a.objects.collections.Map.MyMap();
  	for (Iterator it = mm.keySet().iterator(); it.hasNext(); ){
      Object key = it.next();
      Object val = mm.get(key);
      map.put(key, val);
  	}
  	return map;
	}

	@SuppressWarnings("rawtypes")
	public Object newMap(){
  	java.util.Map<Object, Object> mm = new HashMap();
  	
  	MyMap map = new anywheresoftware.b4a.objects.collections.Map.MyMap();
  	for (Iterator it = mm.keySet().iterator(); it.hasNext(); ){
      Object key = it.next();
      Object val = mm.get(key);
      map.put(key, val);
  	}
  	map.put("id", mm. hashCode());
  	return map;
	}
	
  public static class User{
    private String name;
    private String surname;
    private long phone;
  
    public String getName() {return name;}
    public void setName(String name) {this.name = name;}

    public String getSurname() {return surname;}
    public void setSurname(String surname) {this.surname = surname;}

    public long getPhone() {return phone;}
    public void setPhone(long phone) {this.phone = phone;}

    @Override
    public String toString() {
            return "User [name=" + name + ", surname=" + surname + ", phone="
                            + phone + "]";
    }
    
    
  
   
  }
	
}
